﻿using Microsoft.IdentityModel.Tokens;
using System.IdentityModel.Tokens.Jwt;
using System.Security.Claims;
using System.Text;

namespace TestServer.Services
{
    /// <summary>
    /// 토큰 빌더
    /// </summary>
    public class TokenBuilder : ITokenBuilder
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 토큰 만들기 - BuildToken(userName)

        /// <summary>
        /// 토큰 만들기
        /// </summary>
        /// <param name="userName">사용자명</param>
        /// <returns>토큰</returns>
        public string BuildToken(string userName)
        {
            SymmetricSecurityKey securityKey = new SymmetricSecurityKey
            (
                Encoding.UTF8.GetBytes("placeholder-key-that-is-long-enough-for-sha256")
            );
            
            SigningCredentials signingCredentials = new SigningCredentials(securityKey, SecurityAlgorithms.HmacSha256);
            
            Claim[] claimArray = new Claim[]
            {
                new Claim(JwtRegisteredClaimNames.Sub, userName)
            };
            
            JwtSecurityToken jwtSecurityToken = new JwtSecurityToken(claims : claimArray, signingCredentials : signingCredentials);
            
            string token = new JwtSecurityTokenHandler().WriteToken(jwtSecurityToken);
            
            return token;
        }

        #endregion
    }
}